.varorient =
  array(data=
        c(0.5943587898,-0.0421413736,0.0191881099,-0.8028658356,0.7968790658,
          -0.1035779783,-0.0144029698,0.5950192529,0.0308004582,0.2814099667,
          0.9585939930,0.0309405710,0.1037916914,0.9530499135,-0.2837638585,
          0.0200304694,-0.2317534793,0.0666472619,0.0107016794,0.9704297715,
          -0.9475378720,0.2102996100,-0.0042037081,-0.2406831611,-0.0581112759,
          -0.2640506860,-0.9626417432,0.0148724293,-0.2123331948,-0.9389406008,
          0.2705340592,0.0107928414,-0.0398509239,0.4633862956,0.0280459598,
          0.8848155000,-0.0799662431,0.8799519386,0.0469167607,-0.4659278950,
          -0.6009570366,-0.0101140263,-0.7992093916,0.0035630055,-0.7942719584,
          -0.1041894108,0.5985621021,-0.0001805743,0.0332725637,-0.4627693626,
          0.0059321403,0.8858342188,0.0680367268,-0.8832042073,0.0058665630,
          -0.4639902105,0.0587516720,0.0124189278,0.9981924836,-0.0024035392,
          0.9953954899,0.0751040310,-0.0595160388,0.0022459531),
        dim=c(4,4,4))
.varshape = c(8.2331170,1.7615498,0.4422505,0.1559095)

.decor.opts = c('both','cycle','channel','none')

.theta0 = c(0.8806742,1.3727418,0.883865,1.545728)

.my.colors = c("black","green","blue","chocolate3","red",
  "#007F7F","#66B20E","#7F7F00","#66338E","#7F007F",
  "#E6330E","#7F464E","#7F6035","#6C5649","#685F4C",
  "gray")

.batch.optlist = c("length","information","base","ratio","iupac")

setClass("RolexaRun",
         representation=representation(
           verbose="integer",
           colors="character",
           MinimumTagLength="integer",
           SequencingLength="integer",
           Barcode="integer",
           HThresholds="numeric",
           IThresholds="numeric",
           PET="logical",
           fit="logical",
           normal="logical",
           decorrelate="character",
           idsep="character"),
         prototype=prototype(
           verbose=as.integer(0),
           colors=.my.colors,
           MinimumTagLength=as.integer(15),
           SequencingLength=as.integer(36),
           Barcode=as.integer(0),
           HThresholds=log2(c(1.5,2.5,3.5)),
           IThresholds=log2(4+1:36/6),
           PET=FALSE,
           fit=FALSE,
           normal=TRUE,
           decorrelate="both",
           idsep=":"))

"GetModel" <- function(run) {
    list(MinimumTagLength=run@MinimumTagLength,
         SequencingLength=run@SequencingLength,
         Barcode=run@Barcode,
         HThresholds=run@HThresholds,
         IThresholds=run@IThresholds,
         PET=run@PET,
         fit=run@fit,
         normal=run@normal,
         decorrelate=run@decorrelate,
         verbose=run@verbose,
         colors=run@colors,
         idsep=run@idsep)
}

"SetModel" <- function(run,
                       MinimumTagLength,
                       SequencingLength,
                       Barcode,
                       HThresholds,
                       IThresholds,
                       normal,
                       decorrelate,
                       fit,
                       PET,
                       barcode,
                       idsep,
                       colors) {
    if (missing(run)) run = new("RolexaRun")
    if (!missing(MinimumTagLength)) run@MinimumTagLength=MinimumTagLength
    if (!missing(SequencingLength)) run@SequencingLength=SequencingLength
    if (!missing(Barcode)) run@Barcode=Barcode
    if (!missing(HThresholds)) run@HThresholds=HThresholds
    if (!missing(IThresholds)) run@IThresholds=IThresholds
    if (!missing(normal)) run@normal = normal
    if (!missing(decorrelate)) {
        w = charmatch( decorrelate, .decor.opts, nomatch=1 )
        if (!w) stop("Ambiguous 'decorrelate' parameter")
        run@decorrelate = .decor.opts[w]
    }
    if (!missing(fit)) run@fit = as.logical(fit)
    if (!missing(PET)) run@PET = as.logical(PET)
    if (!missing(barcode)) run@barcode = as.integer(barcode)
    if (!missing(idsep)) run@idsep=idsep
    if (!missing(colors)) run@colors=colors
    run
}
